#include <iostream>
#include <string>
#include <stdlib.h>
#include <assert.h>
#include "fila.h"
using namespace std;

void inicializa(FILA* f){
   f->primeiro = 1;
   f->ultimo = 0;
}

void insere(FILA* f, void* chave){
   assert(!cheia(f));
   f->ultimo = (f->ultimo + 1) % MAX_FILA;
   f->A[f->ultimo] = chave;
}

void* remove(FILA* f){
   assert(!vazia(f));
   void* chave = f->A[f->primeiro];
   f->primeiro = (f->primeiro + 1) % MAX_FILA;
   return chave;
}

bool vazia(FILA* f){
   if(((f->ultimo + 1) % MAX_FILA) == f->primeiro){
      return true;
   }
   return false;
}

bool cheia(FILA* f){
   if(((f->ultimo + 2) % MAX_FILA ) == f->primeiro){
      return true;
   }

   return false;
}

/*
int main() {
   FILA fila;
   inicializa(&fila);
   string s1 = "str 1";
   string s2 = "str 2";
   string s3 = "str 3";
   string s4 = "str 4";
   string s5 = "str 5";

   // só pode enfileirar ponteiros
   insere(&fila, &s1); // enfileira o endereço de (ponteiro para) s1
   insere(&fila, &s2);
   insere(&fila, &s3);
   insere(&fila, &s4);
   insere(&fila, &s5);

   while(!vazia(&fila)) {
      // na hora de desenfileirar, tem que fazer type casting
      // para o tipo específico do ponteiro, pois a função
      // remove devolve um ponteiro "genérico" (void*)
      string* ponteiro_para_string = (string*) remove(&fila);

      string conteudo_da_string = *ponteiro_para_string;
      cout << conteudo_da_string << endl;
   }
}
*/
