#include <iostream>
#include <string>
#include <stdlib.h>
#include <assert.h>
#include "fila.cpp"
using namespace std;

typedef struct Coordenada {
   int x, y;
   struct Coordenada * antecessor;
} Coordenada;

#define LIVRE ' '
#define DESTINO '+'
#define VISITADO '#'
#define ORIGEM '-'
#define ROTA '.'

#define MAX_LINHAS 50
#define MAX_COLUNAS 50

char mapa[MAX_LINHAS][MAX_COLUNAS];
Coordenada origem;
int n, m;

void imprimeCaminho(Coordenada* c);
Coordenada* copiaCoordenada(Coordenada* c);
void encontraCaminhoMinimo();
void imprimeMatriz();
void leMatriz();
bool mesmaCoordenada(Coordenada* a, Coordenada* b);

void encontraCaminhoMinimo() {
   int x [] = {-1,0,1,0};
   int y [] = {0,1,0,-1};
   FILA fila;
   inicializa(&fila);
   Coordenada* coord;
   Coordenada vizinho;
   insere(&fila, &origem);

   while(true){
      if(vazia(&fila)){
         cout << "Impossivel" << endl;
         return;
      }

      coord = (Coordenada*) remove(&fila);

      for(int i = 0; i < 4; i++){
         vizinho.x = coord->x + x[i];
         vizinho.y = coord->y + y[i];

         if(mapa[vizinho.x][vizinho.y] == DESTINO){
            Coordenada* copia_c = copiaCoordenada(&vizinho);
            copia_c->antecessor = coord;
            imprimeCaminho(copia_c);
            return;
         }

         if(mapa[vizinho.x][vizinho.y] == LIVRE){
            Coordenada* copia_c = copiaCoordenada(&vizinho);
            insere(&fila, copia_c);
            mapa[vizinho.x][vizinho.y] = VISITADO;
            copia_c->antecessor = coord;
         }
      }
   }
}

void imprimeCaminho(Coordenada* c) {
   while(!mesmaCoordenada(c->antecessor, &origem)){
      mapa[c->antecessor->x][c->antecessor->y] = ROTA;
      c = c->antecessor;
   }

   for(int j = 0; j < n; j++){
      for(int k = 0 ; k < m; k++){
         if(mapa[j][k] == VISITADO){
            mapa[j][k] = LIVRE;
         }
      }
   }

   imprimeMatriz();
}

void imprimeMatriz() {
   for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
         cout << mapa[i][j];
		}

		cout << endl;
	}
}

void leMatriz() {
	cin >> n >> m;
   string linha;
   getline(cin, linha);

	for (int x = 0; x < n; x++) {
      getline(cin, linha);

		for (int y = 0; y < m; y++) {
         mapa[x][y] = linha.at(y);

         if (mapa[x][y] == ORIGEM) {
            origem.x = x;
            origem.y = y;
            origem.antecessor = NULL;
			}
		}
	}
}

Coordenada* copiaCoordenada(Coordenada* c) {
   Coordenada* copia_c = (Coordenada*) malloc(sizeof(Coordenada));
   memcpy(copia_c, c, sizeof(Coordenada));
   return copia_c;
}

bool mesmaCoordenada(Coordenada* a, Coordenada* b) {
   return a->x == b->x && a->y == b->y;
}

int main() {
   leMatriz();
   encontraCaminhoMinimo();
}
