#include <iostream>
#include <string>
#include <stdlib.h>
#include <assert.h>
#include "fila.cpp"
using namespace std;

typedef struct Coordenada {
   int x, y;
   struct Coordenada * antecessor;
} Coordenada;

#define LIVRE ' '
#define DESTINO '+'
#define VISITADO '#'
#define ORIGEM '-'
#define ROTA '.'

#define MAX_LINHAS 50
#define MAX_COLUNAS 50

char mapa[MAX_LINHAS][MAX_COLUNAS];
Coordenada origem;
int n, m;

void imprimeCaminho(Coordenada* c);
Coordenada* copiaCoordenada(Coordenada* c);
void caminhoMinimo();
void imprimeMatriz();
void leMatriz();
bool mesmaCoordenada(Coordenada* a, Coordenada* b);

void caminhoMinimo() {
   int i = 0;
   int posX[] = { 0, 0, -1, 1 };
   int posY[] = { 1, -1, 0, 0 };
   FILA fila;
   inicializa(&fila);
   insere(&fila, &origem);

   while (!vazia(&fila)) {
      Coordenada* atual = (Coordenada*) remove(&fila);

      // olha as 4 posições vizinhas (esquerda, direita, superior e inferior)
      for (i = 0; i < 4; i++) {
         Coordenada vizinho;
         vizinho.x = atual->x + posX[i];
         vizinho.y = atual->y + posY[i];
         vizinho.antecessor = atual;

         if (mapa[vizinho.x][vizinho.y] == DESTINO) {
				imprimeCaminho(vizinho.antecessor);
				return;
			} else if (mapa[vizinho.x][vizinho.y] == LIVRE) {
				mapa[vizinho.x][vizinho.y] = VISITADO;
				insere(&fila, copiaCoordenada(&vizinho));
				//imprimeMatriz();
            //cout << endl << endl;
			}
		}
	}

	cout << "Impossível." << endl;
}

void imprimeMatriz() {
   for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
         cout << mapa[i][j];
		}

		cout << endl;
	}
}

void imprimeCaminho(Coordenada* c) {
   int i, j;

   while (!mesmaCoordenada(c, &origem)) {
      mapa[c->x][c->y] = ROTA;
      c = c->antecessor;
	}

	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			if (mapa[i][j] == VISITADO) {
            cout << LIVRE;
			} else {
            cout << mapa[i][j];
			}
		}

		cout << endl;
	}
}

void leMatriz() {
	cin >> n >> m;
   string linha;
   getline(cin, linha);

	for (int x = 0; x < n; x++) {
      getline(cin, linha);

		for (int y = 0; y < m; y++) {
         mapa[x][y] = linha.at(y);

         if (mapa[x][y] == ORIGEM) {
            origem.x = x;
            origem.y = y;
            origem.antecessor = NULL;
			}
		}
	}
}

Coordenada* copiaCoordenada(Coordenada* c) {
   Coordenada* copia_c = (Coordenada*) malloc(sizeof(Coordenada));
   memcpy(copia_c, c, sizeof(Coordenada));
   return copia_c;
}

bool mesmaCoordenada(Coordenada* a, Coordenada* b) {
   return a->x == b->x && a->y == b->y;
}
int main() {
   leMatriz();
   caminhoMinimo();
}
